<?xml version="1.0" encoding="utf-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="Docutils 0.16: http://docutils.sourceforge.net/" />
<title>tuning-ref.rst</title>
<meta name="author" content="Arvid Norberg, arvid&#64;libtorrent.org" />
<meta name=viewport content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="style.css" type="text/css" />
<link rel="stylesheet" type="text/css" href="rst.css" />
<style type="text/css">
/* Hides from IE-mac \*/
* html pre { height: 1%; }
/* End hide from IE-mac */
</style>
</head>
<body>
<div class="document">
    <div id="container">
    <a href="index.html"><table id="header">
    <tr><td id="orange"></td>
    <td id="logo">libtorrent</td></tr>
    </table></a>
    <div id="main">

<table class="docinfo" frame="void" rules="none">
<col class="docinfo-name" />
<col class="docinfo-content" />
<tbody valign="top">
<tr><th class="docinfo-name">Author:</th>
<td>Arvid Norberg, <a class="last reference external" href="mailto:arvid&#64;libtorrent.org">arvid&#64;libtorrent.org</a></td></tr>
<tr><th class="docinfo-name">Version:</th>
<td>1.2.9</td></tr>
</tbody>
</table>
<div class="contents topic" id="table-of-contents">
<p class="topic-title">Table of contents</p>
<ul class="simple">
<li><a class="reference internal" href="#tuning-libtorrent" id="id45">tuning libtorrent</a></li>
<li><a class="reference internal" href="#profiling" id="id46">profiling</a></li>
<li><a class="reference internal" href="#reducing-memory-footprint" id="id47">reducing memory footprint</a><ul>
<li><a class="reference internal" href="#disable-disk-cache" id="id48">disable disk cache</a></li>
<li><a class="reference internal" href="#remove-torrents" id="id49">remove torrents</a></li>
<li><a class="reference internal" href="#socket-buffer-sizes" id="id50">socket buffer sizes</a></li>
<li><a class="reference internal" href="#peer-list-size" id="id51">peer list size</a></li>
<li><a class="reference internal" href="#send-buffer-watermark" id="id52">send buffer watermark</a></li>
<li><a class="reference internal" href="#reduce-executable-size" id="id53">reduce executable size</a></li>
</ul>
</li>
<li><a class="reference internal" href="#high-performance-seeding" id="id54">high performance seeding</a><ul>
<li><a class="reference internal" href="#file-pool" id="id55">file pool</a></li>
<li><a class="reference internal" href="#disk-cache" id="id56">disk cache</a></li>
<li><a class="reference internal" href="#utp-tcp-mixed-mode" id="id57">uTP-TCP mixed mode</a></li>
<li><a class="reference internal" href="#send-buffer-low-watermark" id="id58">send buffer low watermark</a></li>
<li><a class="reference internal" href="#peers" id="id59">peers</a></li>
<li><a class="reference internal" href="#torrent-limits" id="id60">torrent limits</a></li>
<li><a class="reference internal" href="#sha-1-hashing" id="id61">SHA-1 hashing</a></li>
</ul>
</li>
<li><a class="reference internal" href="#scalability" id="id62">scalability</a></li>
<li><a class="reference internal" href="#benchmarking" id="id63">benchmarking</a></li>
<li><a class="reference internal" href="#understanding-the-disk-threads" id="id64">understanding the disk threads</a></li>
<li><a class="reference internal" href="#contributions" id="id65">contributions</a></li>
</ul>
</div>
<div class="section" id="tuning-libtorrent">
<h1>tuning libtorrent</h1>
<p>libtorrent expose most parameters used in the bittorrent engine for
customization through the <a class="reference external" href="reference-Settings.html#settings_pack">settings_pack</a>. This makes it possible to
test and tweak the parameters for certain algorithms to make a client
that fits a wide range of needs. From low memory embedded devices to
servers seeding thousands of torrents. The default settings in libtorrent
are tuned for an end-user bittorrent client running on a normal desktop
computer.</p>
<p>This document describes techniques to benchmark libtorrent performance
and how parameters are likely to affect it.</p>
</div>
<div class="section" id="profiling">
<h1>profiling</h1>
<p>libtorrent is instrumented with a number of counters and gauges you can have
access to via the <tt class="docutils literal">session_stats_alert</tt>. First, enable these alerts in the
<a class="reference external" href="reference-Alerts.html#alert">alert</a> mask:</p>
<pre class="literal-block">
settings_pack p;
p.set_int(settings_mask::alert_mask, alert::stats_notification);
ses.apply_settings(p);
</pre>
<p>Then print alerts to a file:</p>
<pre class="literal-block">
std::vector&lt;alert*&gt; alerts;
ses.pop_alerts(&amp;alerts);

for (auto* a : alerts) {
        std::cout &lt;&lt; a-&gt;message() &lt;&lt; &quot;\n&quot;;
}
</pre>
<p>If you want to separate generic alerts from <a class="reference external" href="reference-Session.html#session">session</a> stats, you can filter on the
<a class="reference external" href="reference-Alerts.html#alert">alert</a> category in the <a class="reference external" href="reference-Alerts.html#alert">alert</a>, <tt class="docutils literal"><span class="pre">alert::category()</span></tt>.</p>
<p>The alerts with data will have the type <a class="reference external" href="reference-Alerts.html#session_stats_alert">session_stats_alert</a> and there is one
session_log_alert that will be posted on startup containing the column names
for all metrics. Logging this line will greatly simplify interpreting the output.</p>
<p>The python scrip in <tt class="docutils literal">tools/parse_session_stats.py</tt> can parse the resulting
file and produce graphs of relevant stats. It requires <a class="reference external" href="http://www.gnuplot.info">gnuplot</a>.</p>
</div>
<div class="section" id="reducing-memory-footprint">
<h1>reducing memory footprint</h1>
<p>These are things you can do to reduce the memory footprint of libtorrent. You get
some of this by basing your default <a class="reference external" href="reference-Settings.html#settings_pack">settings_pack</a> on the <a class="reference external" href="reference-Settings.html#min_memory_usage()">min_memory_usage()</a>
setting preset function.</p>
<p>Keep in mind that lowering memory usage will affect performance, always profile
and benchmark your settings to determine if it's worth the trade-off.</p>
<p>The typical buffer usage of libtorrent, for a single download, with the cache
size set to 256 blocks (256 * 16 kiB = 4 MiB) is:</p>
<pre class="literal-block">
read cache:      128.6 (2058 kiB)
write cache:     103.5 (1656 kiB)
receive buffers: 7.3   (117 kiB)
send buffers:    4.8   (77 kiB)
hash temp:       0.001 (19 Bytes)
</pre>
<p>The receive buffers is proportional to the number of connections we make, and is
limited by the total number of connections in the <a class="reference external" href="reference-Session.html#session">session</a> (default is 200).</p>
<p>The send buffers is proportional to the number of upload slots that are allowed
in the <a class="reference external" href="reference-Session.html#session">session</a>. The default is auto configured based on the observed upload rate.</p>
<p>The read and write cache can be controlled (see section below).</p>
<p>The &quot;hash temp&quot; <a class="reference external" href="reference-Bencoding.html#entry">entry</a> size depends on whether or not hashing is optimized for
speed or memory usage. In this test run it was optimized for memory usage.</p>
<div class="section" id="disable-disk-cache">
<h2>disable disk cache</h2>
<p>The bulk of the memory libtorrent will use is used for the disk cache. To save
the absolute most amount of memory, you can disable the cache by setting
<a class="reference external" href="reference-Settings.html#cache_size">settings_pack::cache_size</a> to 0. You might want to consider using the cache
but just disable caching read operations. You do this by settings
<a class="reference external" href="reference-Settings.html#use_read_cache">settings_pack::use_read_cache</a> to false. This is the main factor in how much
memory will be used by the client. Keep in mind that you will degrade performance
by disabling the cache. You should benchmark the disk access in order to make an
informed trade-off.</p>
</div>
<div class="section" id="remove-torrents">
<h2>remove torrents</h2>
<p>Torrents that have been added to libtorrent will inevitably use up memory, even
when it's paused. A paused torrent will not use any peer connection objects or
any send or receive buffers though. Any added torrent holds the entire .torrent
file in memory, it also remembers the entire list of peers that it's heard about
(which can be fairly long unless it's capped). It also retains information about
which blocks and pieces we have on disk, which can be significant for torrents
with many pieces.</p>
<p>If you need to minimize the memory footprint, consider removing torrents from
the <a class="reference external" href="reference-Session.html#session">session</a> rather than pausing them. This will likely only make a difference
when you have a very large number of torrents in a <a class="reference external" href="reference-Session.html#session">session</a>.</p>
<p>The downside of removing them is that they will no longer be auto-managed. Paused
auto managed torrents are scraped periodically, to determine which torrents are
in the greatest need of seeding, and libtorrent will prioritize to seed those.</p>
</div>
<div class="section" id="socket-buffer-sizes">
<h2>socket buffer sizes</h2>
<p>You can make libtorrent explicitly set the kernel buffer sizes of all its peer
sockets. If you set this to a low number, you may see reduced throughput, especially
for high latency connections. It is however an opportunity to save memory per
connection, and might be worth considering if you have a very large number of
peer connections. This memory will not be visible in your process, this sets
the amount of kernel memory is used for your sockets.</p>
<p>Change this by setting <a class="reference external" href="reference-Settings.html#recv_socket_buffer_size">settings_pack::recv_socket_buffer_size</a> and
<a class="reference external" href="reference-Settings.html#send_socket_buffer_size">settings_pack::send_socket_buffer_size</a>.</p>
</div>
<div class="section" id="peer-list-size">
<h2>peer list size</h2>
<p>The default maximum for the peer list is 4000 peers. For IPv4 peers, each peer
<a class="reference external" href="reference-Bencoding.html#entry">entry</a> uses 32 bytes, which ends up using 128 kB per torrent. If seeding 4 popular
torrents, the peer lists alone uses about half a megabyte.</p>
<p>The default limit is the same for paused torrents as well, so if you have a
large number of paused torrents (that are popular) it will be even more
significant.</p>
<p>If you're short of memory, you should consider lowering the limit. 500 is probably
enough. You can do this by setting <a class="reference external" href="reference-Settings.html#max_peerlist_size">settings_pack::max_peerlist_size</a> to
the max number of peers you want in a torrent's peer list. This limit applies per
torrent. For 5 torrents, the total number of peers in peer lists will be 5 times
the setting.</p>
<p>You should also lower the same limit but for paused torrents. It might even make sense
to set that even lower, since you only need a few peers to start up while waiting
for the tracker and DHT to give you fresh ones. The max peer list size for paused
torrents is set by <a class="reference external" href="reference-Settings.html#max_paused_peerlist_size">settings_pack::max_paused_peerlist_size</a>.</p>
<p>The drawback of lowering this number is that if you end up in a position where
the tracker is down for an extended period of time, your only hope of finding live
peers is to go through your list of all peers you've ever seen. Having a large
peer list will also help increase performance when starting up, since the torrent
can start connecting to peers in parallel with connecting to the tracker.</p>
</div>
<div class="section" id="send-buffer-watermark">
<h2>send buffer watermark</h2>
<p>The send buffer watermark controls when libtorrent will ask the disk I/O thread
to read blocks from disk, and append it to a peer's send buffer.</p>
<p>When the send buffer has fewer than or equal number of bytes as
<a class="reference external" href="reference-Settings.html#send_buffer_watermark">settings_pack::send_buffer_watermark</a>, the peer will ask the disk I/O thread
for more data to send. The trade-off here is between wasting memory by having too
much data in the send buffer, and hurting send rate by starving out the socket,
waiting for the disk read operation to complete.</p>
<p>If your main objective is memory usage and you're not concerned about being able
to achieve high send rates, you can set the watermark to 9 bytes. This will guarantee
that no more than a single (16 kiB) block will be on the send buffer at a time, for
all peers. This is the least amount of memory possible for the send buffer.</p>
<p>You should benchmark your max send rate when adjusting this setting. If you have
a very fast disk, you are less likely see a performance hit.</p>
</div>
<div class="section" id="reduce-executable-size">
<h2>reduce executable size</h2>
<p>Compilers generally add a significant number of bytes to executables that make use
of C++ exceptions. By disabling exceptions (-fno-exceptions on GCC), you can
reduce the executable size with up to 45%. In order to build without exception
support, you need to patch parts of boost.</p>
<p>Also make sure to optimize for size when compiling.</p>
<p>Another way of reducing the executable size is to disable code that isn't used.
There are a number of <tt class="docutils literal">TORRENT_*</tt> macros that control which features are included
in libtorrent. If these macros are used to strip down libtorrent, make sure the same
macros are defined when building libtorrent as when linking against it. If these
are different the structures will look different from the libtorrent side and from
the client side and memory corruption will follow.</p>
<p>One, probably, safe macro to define is <tt class="docutils literal">TORRENT_NO_DEPRECATE</tt> which removes all
deprecated functions and struct members. As long as no deprecated functions are
relied upon, this should be a simple way to eliminate a little bit of code.</p>
<p>For all available options, see the <a class="reference external" href="building.html">building libtorrent</a> section.</p>
</div>
</div>
<div class="section" id="high-performance-seeding">
<h1>high performance seeding</h1>
<p>In the case of a high volume seed, there are two main concerns. Performance and scalability.
This translates into high send rates, and low memory and CPU usage per peer connection.</p>
<div class="section" id="file-pool">
<h2>file pool</h2>
<p>libtorrent keeps an LRU file cache. Each file that is opened, is stuck in the cache. The main
purpose of this is because of anti-virus software that hooks on file-open and file close to
scan the file. Anti-virus software that does that will significantly increase the cost of
opening and closing files. However, for a high performance seed, the file open/close might
be so frequent that it becomes a significant cost. It might therefore be a good idea to allow
a large file descriptor cache. Adjust this though <a class="reference external" href="reference-Settings.html#file_pool_size">settings_pack::file_pool_size</a>.</p>
<p>Don't forget to set a high rlimit for file descriptors in your process as well. This limit
must be high enough to keep all connections and files open.</p>
</div>
<div class="section" id="disk-cache">
<h2>disk cache</h2>
<p>You typically want to set the cache size to as high as possible. The
<a class="reference external" href="reference-Settings.html#cache_size">settings_pack::cache_size</a> is specified in 16 kiB blocks. Since you're seeding,
the cache would be useless unless you also set <a class="reference external" href="reference-Settings.html#use_read_cache">settings_pack::use_read_cache</a>
to true.</p>
<p>In order to increase the possibility of read cache hits, set the
<a class="reference external" href="reference-Settings.html#cache_expiry">settings_pack::cache_expiry</a> to a large number. This won't degrade anything as
long as the client is only seeding, and not downloading any torrents.</p>
<p>There's a <em>guided cache</em> mode. This means the size of the read cache line that's
stored in the cache is determined based on the upload rate to the peer that
triggered the read operation. The idea being that slow peers don't use up a
disproportional amount of space in the cache. This is enabled through
settings_pack::guided_read_cache.</p>
<p>In cases where the assumption is that the cache is only used as a read-ahead, and that no
other peer will ever request the same block while it's still in the cache, the read
cache can be set to be <em>volatile</em>. This means that every block that is requested out of
the read cache is removed immediately. This saves a significant amount of cache space
which can be used as read-ahead for other peers. To enable volatile read cache, set
<a class="reference external" href="reference-Settings.html#volatile_read_cache">settings_pack::volatile_read_cache</a> to true.</p>
</div>
<div class="section" id="utp-tcp-mixed-mode">
<h2>uTP-TCP mixed mode</h2>
<p>libtorrent supports <a class="reference external" href="utp.html">uTP</a>, which has a delay based congestion controller. In order to
avoid having a single TCP bittorrent connection completely starve out any uTP connection,
there is a mixed mode algorithm. This attempts to detect congestion on the uTP peers and
throttle TCP to avoid it taking over all bandwidth. This balances the bandwidth resources
between the two protocols. When running on a network where the bandwidth is in such an
abundance that it's virtually infinite, this algorithm is no longer necessary, and might
even be harmful to throughput. It is advised to experiment with the
<a class="reference external" href="reference-Settings.html#mixed_mode_algorithm">settings_pack::mixed_mode_algorithm</a>, setting it to <a class="reference external" href="reference-Settings.html#prefer_tcp">settings_pack::prefer_tcp</a>.
This setting entirely disables the balancing and un-throttles all connections. On a typical
home connection, this would mean that none of the benefits of uTP would be preserved
(the modem's send buffer would be full at all times) and uTP connections would for the most
part be squashed by the TCP traffic.</p>
</div>
<div class="section" id="send-buffer-low-watermark">
<h2>send buffer low watermark</h2>
<p>libtorrent uses a low watermark for send buffers to determine when a new piece should
be requested from the disk I/O subsystem, to be appended to the send buffer. The low
watermark is determined based on the send rate of the socket. It needs to be large
enough to not draining the socket's send buffer before the disk operation completes.</p>
<p>The watermark is bound to a max value, to avoid buffer sizes growing out of control.
The default max send buffer size might not be enough to sustain very high upload rates,
and you might have to increase it. It's specified in bytes in
<a class="reference external" href="reference-Settings.html#send_buffer_watermark">settings_pack::send_buffer_watermark</a>.</p>
</div>
<div class="section" id="peers">
<h2>peers</h2>
<p>First of all, in order to allow many connections, set the global connection limit
high, <a class="reference external" href="reference-Settings.html#connections_limit">settings_pack::connections_limit</a>. Also set the upload rate limit to
infinite, <a class="reference external" href="reference-Settings.html#upload_rate_limit">settings_pack::upload_rate_limit</a>, 0 means infinite.</p>
<p>When dealing with a large number of peers, it might be a good idea to have slightly
stricter timeouts, to get rid of lingering connections as soon as possible.</p>
<p>There are a couple of relevant settings: <a class="reference external" href="reference-Settings.html#request_timeout">settings_pack::request_timeout</a>,
<a class="reference external" href="reference-Settings.html#peer_timeout">settings_pack::peer_timeout</a> and <a class="reference external" href="reference-Settings.html#inactivity_timeout">settings_pack::inactivity_timeout</a>.</p>
<p>For seeds that are critical for a delivery system, you most likely want to allow
multiple connections from the same IP. That way two people from behind the same NAT
can use the service simultaneously. This is controlled by
<a class="reference external" href="reference-Settings.html#allow_multiple_connections_per_ip">settings_pack::allow_multiple_connections_per_ip</a>.</p>
<p>In order to always unchoke peers, turn off automatic unchoke by setting
<a class="reference external" href="reference-Settings.html#choking_algorithm">settings_pack::choking_algorithm</a> to settings_pack::fixed_slot_choker and set the number
of upload slots to a large number via <a class="reference external" href="reference-Settings.html#unchoke_slots_limit">settings_pack::unchoke_slots_limit</a>,
or use -1 (which means infinite).</p>
</div>
<div class="section" id="torrent-limits">
<h2>torrent limits</h2>
<p>To seed thousands of torrents, you need to increase the <a class="reference external" href="reference-Settings.html#active_limit">settings_pack::active_limit</a>
and <a class="reference external" href="reference-Settings.html#active_seeds">settings_pack::active_seeds</a>.</p>
</div>
<div class="section" id="sha-1-hashing">
<h2>SHA-1 hashing</h2>
<p>When downloading at very high rates, it is possible to have the CPU be the
bottleneck for passing every downloaded byte through SHA-1. In order to enable
calculating SHA-1 hashes in parallel, on multi-core systems, set
<a class="reference external" href="reference-Settings.html#aio_threads">settings_pack::aio_threads</a> to the number of threads libtorrent should
perform I/O and do SHA-1 hashing in. Only if that thread is close to saturating
one core does it make sense to increase the number of threads.</p>
</div>
</div>
<div class="section" id="scalability">
<h1>scalability</h1>
<p>In order to make more efficient use of the libtorrent interface when running a large
number of torrents simultaneously, one can use the <tt class="docutils literal"><span class="pre">session::get_torrent_status()</span></tt> call
together with <tt class="docutils literal"><span class="pre">session::post_torrent_updates()</span></tt>. Keep in mind that every call into
libtorrent that return some value have to block your thread while posting a message to
the main network thread and then wait for a response. Calls that don't return any data
will simply post the message and then immediately return, performing the work
asynchronously. The time this takes might become significant once you reach a
few hundred torrents, depending on how many calls you make to each torrent and how often.
<tt class="docutils literal"><span class="pre">session::get_torrent_status()</span></tt> lets you query the status of all torrents in a single call.
This will actually loop through all torrents and run a provided predicate function to
determine whether or not to include it in the returned vector.</p>
<p>To use <tt class="docutils literal"><span class="pre">session::post_torrent_updates()</span></tt> torrents need to have the <tt class="docutils literal">flag_update_subscribe</tt>
flag set. When <a class="reference external" href="reference-Session.html#post_torrent_updates()">post_torrent_updates()</a> is called, a <a class="reference external" href="reference-Alerts.html#state_update_alert">state_update_alert</a> <a class="reference external" href="reference-Alerts.html#alert">alert</a>
is posted, with all the torrents that have updated since the last time this
function was called. The client have to keep its own state of all torrents, and
update it based on this <a class="reference external" href="reference-Alerts.html#alert">alert</a>.</p>
</div>
<div class="section" id="benchmarking">
<h1>benchmarking</h1>
<p>There is a bunch of built-in instrumentation of libtorrent that can be used to get an insight
into what it's doing and how well it performs. This instrumentation is enabled by defining
preprocessor symbols when building.</p>
<p>There are also a number of scripts that parses the log files and generates graphs (requires
gnuplot and python).</p>
</div>
<div class="section" id="understanding-the-disk-threads">
<h1>understanding the disk threads</h1>
<p><em>This section is somewhat outdated, there are potentially more than one disk
thread</em></p>
<p>All disk operations are funneled through a separate thread, referred to as the
disk thread. The main interface to the disk thread is a queue where disk jobs
are posted, and the results of these jobs are then posted back on the main
thread's io_service.</p>
<p>A disk job is essentially one of:</p>
<ol class="arabic simple">
<li><dl class="first docutils">
<dt>write this block to disk, i.e. a write job. For the most part this is just a</dt>
<dd>matter of sticking the block in the disk cache, but if we've run out of
cache space or completed a whole piece, we'll also flush blocks to disk.
This is typically very fast, since the OS just sticks these buffers in its
write cache which will be flushed at a later time, presumably when the drive
head will pass the place on the platter where the blocks go.</dd>
</dl>
</li>
<li><dl class="first docutils">
<dt>read this block from disk. The first thing that happens is we look in the</dt>
<dd>cache to see if the block is already in RAM. If it is, we'll return
immediately with this block. If it's a cache miss, we'll have to hit the
disk. Here we decide to defer this job. We find the physical offset on the
drive for this block and insert the job in an ordered queue, sorted by the
physical location. At a later time, once we don't have any more non-read
jobs left in the queue, we pick one read job out of the ordered queue and
service it. The order we pick jobs out of the queue is according to an
elevator cursor moving up and down along the ordered queue of read jobs. If
we have enough space in the cache we'll read read_cache_line_size number of
blocks and stick those in the cache. This defaults to 32 blocks. If the
system supports asynchronous I/O (Windows, Linux, Mac OS X, BSD, Solars for
instance), jobs will be issued immediately to the OS. This especially
increases read throughput, since the OS has a much greater flexibility to
reorder the read jobs.</dd>
</dl>
</li>
</ol>
<p>Other disk job consist of operations that needs to be synchronized with the
disk I/O, like renaming files, closing files, flushing the cache, updating the
settings etc. These are relatively rare though.</p>
</div>
<div class="section" id="contributions">
<h1>contributions</h1>
<p>If you have added instrumentation for some part of libtorrent that is not
covered here, or if you have improved any of the parser scrips, please consider
contributing it back to the project.</p>
<p>If you have run tests and found that some algorithm or default value in
libtorrent are suboptimal, please contribute that knowledge back as well, to
allow us to improve the library.</p>
<p>If you have additional suggestions on how to tune libtorrent for any specific
use case, please let us know and we'll update this document.</p>
</div>

    </div>
    </div>
    <div id="gradient"></div>
    <div id="footer">
    <table>
    <tr>
      <td><a href="index.html">home</a></td>
      <td><a href="https://blog.libtorrent.org">blog</a></td>
      <td><a href="utp.html">uTP</a></td>
    </tr>
    <tr>
      <td><a href="https://sourceforge.net/projects/libtorrent/files/libtorrent/">download</a></td>
      <td><a href="reference.html">documentation</a></td>
      <td><a href="dht_store.html">DHT put extension</a></td>
    </tr>
    <tr>
      <td><a href="https://sourceforge.net/projects/libtorrent/files/py-libtorrent/">python bindings</a></td>
      <td><a href="features.html">features</a></td>
      <td><a href="dht_sec.html">DHT security extension</a></td>
    </tr>
    <tr>
      <td><a href="https://sourceforge.net/p/libtorrent/mailman/libtorrent-discuss/">mailing list archive</a></td>
      <td><a href="contributing.html">contributing</a></td>
      <td><a href="streaming.html">streaming</a></td>
    </tr>
    <tr>
      <td><a href="https://github.com/arvidn/libtorrent/issues">report a bug</a></td>
      <td><a href="building.html">building</a></td>
      <td><a href="bittorrent.pdf">bittorrent slides</a></td>
    </tr>
    </table>
    </div>
    <div id="filler"></div>

</div>
</body>
</html>
